.486


CODE	SEGMENT USE16
		ASSUME	CS:CODE, DS:CODE
		ORG 100H
START:
	jmp 	Init

_INT10HVEC:  dd ?


_3D4_0	db	05Fh
_3D4_1	db	04Fh
_3D4_2	db	051h
_3D4_3	db	083h
_3D4_4	db	054h
_3D4_5	db	09Bh
_3D4_6	db	005h
_3D4_7	db	011h
_3D4_8	db	000h
_3D4_9	db	040h

_3D4_10 db	0F7h
_3D4_11 db	009h
_3D4_12 db	0EFh


_3D4_15 db	0F2h
_3D4_16 db	005h



PLL_2A	db	80h or 81
PLL_2B	db	40h or 30
PLL_13	db	00h
SeqDiv	db	1



Vesa640x480:
	pushf
	pusha
	cli
	call	WritePLL
	call	WriteCrtc
	call	SetInterlace

	call	GetBytePerLine
	add 	eax, eax
	call	SetBytePerLine
	popa
	popf
	ret

GetBytePerLine:
;
;	out eax
;
	push	edx
	xor 	edx, edx
	mov 	ah, 13h
	call	GetCrtcData
	mov 	dl, al
	mov 	ah, 0Ah
	call	GetExtData
	shl 	ax, 4
	and 	ax, 0F00h
	or		dx, ax
	shl 	edx, 3
	mov 	eax, edx
	pop 	edx
	ret


SetBytePerLine:
;
;	in	eax
;
	pusha
	shr 	eax, 3
	mov 	ecx, eax
	mov 	ah, 13h
	mov 	al, cl
	call	SetCrtcData
	mov 	ah, 0Ah
	call	GetExtData
	and 	al, 0Fh
	xor 	ebx, ebx
	shr 	ecx, 4
	and 	ecx, 0F0h
	or		al, cl
	call	SetExtData
	popa
	ret


WritePLL:
	pusha

	mov 	ah, 05h
	mov 	al, 86h
	call	SetExtData

	mov 	dx, 3CCh
	in		al, dx
	or		al, 0Ch
	mov 	dx, 3C2h
	out 	dx, al

	mov 	ah, 38h
	call	GetExtData
	and 	al, 0FCh
	call	SetExtData

	mov 	ah, 13h
	call	GetExtData
	and 	al, not 40h
	or		al, byte ptr[cs:PLL_13]
	call	SetExtData
	mov 	ah, 2Ah
	mov 	al, byte ptr[cs:PLL_2A]
	call	SetExtData
	mov 	ah, 2Bh
	mov 	al, byte ptr[cs:PLL_2B]
	call	SetExtData

	mov 	ah, 01h
	call	GetSeqData
	and 	al, 0F7h
	mov 	al, byte ptr[cs:SeqDiv]
	cmp 	al, 0
	je		WritePLL_SeqDiv_Set
	or		al, 08h
WritePLL_SeqDiv_Set:
	call	SetSeqData
WritePLL_end:
	popa
	ret


WriteCrtc:
	pusha

	mov 	ah, 11h
	call	GetCrtcData
	and 	al, 7Fh
	call	SetCrtcData


	mov 	ah, 0
	mov 	al, byte ptr[cs:_3D4_0]
	call	SetCrtcData
	mov 	ah, 1
	mov 	al, byte ptr[cs:_3D4_1]
	call	SetCrtcData
	mov 	ah, 2
	mov 	al, byte ptr[cs:_3D4_2]
	call	SetCrtcData
	mov 	ah, 3
	mov 	al, byte ptr[cs:_3D4_3]
	call	SetCrtcData
	mov 	ah, 4
	mov 	al, byte ptr[cs:_3D4_4]
	call	SetCrtcData
	mov 	ah, 5
	mov 	al, byte ptr[cs:_3D4_5]
	call	SetCrtcData
	mov 	ah, 6
	mov 	al, byte ptr[cs:_3D4_6]
	call	SetCrtcData
	mov 	ah, 7
	mov 	al, byte ptr[cs:_3D4_7]
	call	SetCrtcData
	mov 	ah, 8
	mov 	al, byte ptr[cs:_3D4_8]
	call	SetCrtcData
	mov 	ah, 9
	mov 	al, byte ptr[cs:_3D4_9]
	call	SetCrtcData

	mov 	ah, 10h
	mov 	al, byte ptr[cs:_3D4_10]
	call	SetCrtcData
	mov 	ah, 11h
	mov 	al, byte ptr[cs:_3D4_11]
	call	SetCrtcData
	mov 	ah, 12h
	mov 	al, byte ptr[cs:_3D4_12]
	call	SetCrtcData

	mov 	ah, 15h
	mov 	al, byte ptr[cs:_3D4_15]
	call	SetCrtcData
	mov 	ah, 16h
	mov 	al, byte ptr[cs:_3D4_16]
	call	SetCrtcData

WriteCrtc_end:
	popa
	ret


SetInterlace:
	pusha
	mov 	ah, 06h
	call	GetExtData
	or		al, 1 shl 5
	call	SetExtData

;	 SetBytePerLine( CurrentBytePerLine * 2);

	popa
	ret


SetDataSub:
;	in	dx	ioport
;		ah	index
;		al	data
;
	push	dx
	xchg	al, ah
	out 	dx, al
	xchg	al, ah
	inc 	dx
	out 	dx, al
	pop 	dx
	ret

GetDataSub:
;	in	dx	ioport
;		ah	index
;	out al	data
;
	push	dx
	mov 	al, ah
	out 	dx, al
	inc 	dx
	in		al, dx
	pop 	dx
	ret

SetCrtcData:
	push	dx
	mov 	dx, 3D4h
	call	SetDataSub
	pop 	dx
	ret

GetCrtcData:
	push	dx
	mov 	dx, 3D4h
	call	GetDataSub
	pop 	dx
	ret

SetSeqData:
	push	dx
	mov 	dx, 3C4h
	call	SetDataSub
	pop 	dx
	ret

GetSeqData:
	push	dx
	mov 	dx, 3C4h
	call	GetDataSub
	pop 	dx
	ret

SetExtData:
	push	dx
	mov 	dx, 3C4h
	call	SetDataSub
	pop 	dx
	ret

GetExtData:
	push	dx
	mov 	dx, 3C4h
	call	GetDataSub
	pop 	dx
	ret


NewVESA:
	cmp 	ax, 4F02h
	jne 	OldVESA
	cmp 	bx, 0101h
	je		MyVESA
	cmp 	bx, 8101h
	je		MyVESA
	jmp 	OldVESA
MyVESA:
	pushf
	call	 dword ptr cs:[_INT10HVEC]
	call	 Vesa640x480
	iret

OldVESA:
	jmp 	dword ptr cs:[_INT10HVEC]



Init:
;	 mov	 ax, cs
;	 mov	 ds, ax

	call	SiS6326Check
	test	ax, ax
	jnz 	exit

	mov 	ah, 35h
	mov 	al, 10h
	INT 	21H
	mov 	word ptr[_INT10HVEC], bx
	mov 	word ptr[_INT10HVEC + 2], es

	mov 	dx, OFFSET NewVESA
	mov 	ah, 25h
	mov 	al, 10h
	INT 	21H

keep:
	mov 	dx, OFFSET INIT
	shr 	dx, 4
	inc 	dx
	mov 	ax, 3100h
	INT 	21H


exit:
	mov 	ah,4ch					;DOS: terminate program
	mov 	al,0					;return code will be 0
	int 	21h 					;terminate the program



SiS6326Check:
	push	ebx ecx edx esi edi

	mov 	eax, 0000b101h
	mov 	edi, 0
	INT 	1Ah
	cmp 	edx, 20494350h
	jne 	SiS6326NotFound

	mov 	eax, 0000b102h
	mov 	ecx, 00000620h
	mov 	edx, 00001039h
	mov 	esi, 0
	INT 	1Ah
	test	ah, ah
	jz		SiS6326Check_SiS620found
	mov 	eax, 0000b102h
	mov 	ecx, 00000530h
	mov 	edx, 00001039h
	mov 	esi, 0
	INT 	1Ah
	test	ah, ah
	jz		SiS6326Check_SiS530found
	mov 	eax, 0000b102h
	mov 	ecx, 00006326h
	mov 	edx, 00001039h
	mov 	esi, 0
	INT 	1Ah
	test	ah, ah
	jz		SiS6326Check_SiS6326found
	jmp 	SiS6326NotFound

SiS6326Check_SiS6326found:
	call	Message_SiS6326Found
	jmp 	SiS6326Check_found

SiS6326Check_SiS620found:
	call	Message_SiS620Found
	jmp 	SiS6326Check_found

SiS6326Check_SiS530found:
	call	Message_SiS530Found
	jmp 	SiS6326Check_found

SiS6326Check_found:
	call	Message
	xor 	eax, eax
SiS6326Check_end:
	pop 	edi esi edx ecx ebx
	ret

SiS6326NotFound:
	call	NotFoundMessage
	mov 	eax, 1
	jmp 	SiS6326Check_end


NotFound_mes:		DB 'SiS not found',13,10,'$'
FoundSiS6326_mes:	DB 'SiS6326 found',13,10,'$'
FoundSiS620_mes:	DB 'SiS620 found',13,10,'$'
FoundSiS530_mes:	DB 'SiS530 found',13,10,'$'
VESA0101h_mes:		DB 'VESA 0101h: 640x480 15KHz Interlaced',13,10,'$'

Message_SiS6326Found:
	pusha
	mov 	ax, cs
	mov 	ds, ax
	mov 	dx, OFFSET FoundSiS6326_mes
	mov 	ah,9					;DOS: print string
	int 	21h
	popa
	ret

Message_SiS620Found:
	pusha
	mov 	ax, cs
	mov 	ds, ax
	mov 	dx, OFFSET FoundSiS620_mes
	mov 	ah,9					;DOS: print string
	int 	21h
	popa
	ret

Message_SiS530Found:
	pusha
	mov 	ax, cs
	mov 	ds, ax
	mov 	dx, OFFSET FoundSiS530_mes
	mov 	ah,9					;DOS: print string
	int 	21h
	popa
	ret

Message:
	pusha
	mov 	ax, cs
	mov 	ds, ax
	mov 	dx, OFFSET VESA0101h_mes
	mov 	ah,9					;DOS: print string
	int 	21h
	popa
	ret

NotFoundMessage:
	pusha
	mov 	ax, cs
	mov 	ds, ax
	mov 	dx, OFFSET NotFound_mes
	mov 	ah,9					;DOS: print string
	int 	21h
	popa
	ret



CODE	ENDS
		END START
